;-mail.asm-v0.1--------------------------------------------------------------
;          x86 - Dos & Win32 - Assembly Language Programming                ;
;                                                                           ;
; Written by: John A Lyons (megablast)                                      ;
; Email     : asm@megablast.8k.com                                          ;
; Page      : http://asmsource.8k.com/                                      ;
; Compiler  : Masm32 v6.13 Microsoft Macro Assembler                        ;
; Date      : 11-Jul-2001                                                   ;
; Purpose   : A program that checks your email POP3 accounts, telling you   ;
;             if you have any unread mail.                                  ;
;                                                                           ;
;             !!!Program will not work until you ass correct server,        ;
;                username and password!!!                                   ;
;                                                                           ;
;      v0.1 : This stage manages to contact mail server. Does nothing       ;
;(27Aug2001): useful at this point, but details how to set up a connection. ;
;             Very early days yet!!! But this is the hard bit, as far as    ;
;             im concerned!!! (Gotta love those exclamation marks)          ;
;                                                                           ;
;                                                                           ;
;----------------------------------------------------------------------------
; Compile with nmake


.386
.MODEL  FLAT , STDCALL

include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include wsock32.inc
includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib wsock32.lib

EXTRN wsprintfA:PROC


.data
;*****************************************************************************
pop3server1             equ $
        servername1     db "saltbush.adelaide.edu.au",0
                           ; ENTER SERVERNAME
        username1       db "------",0
                           ; ENTER USERNAME
        pass1           db "----",0
                           ; ENTER PASSWORD

;*****************************************************************************

;------------constants
EMM_0000        equ 28000       ; Resolved Host Name Messages
EMM_0019        equ 28019       ; /
EMM_1000        equ 28100       ; Connected Messages
EMM_1019        equ 28119       ; /
EMM_2000        equ 28200       ; Ready To Read Messages
EMM_2019        equ 28219       ; /

s1              db "stage 1",0
s2              db "stage 2",0
s3              db "stage 3",0
s4              db "stage 4",0
s5              db "stage 5",0
s6              db "stage 6",0
s7              db "stage 7",0
s8              db "stage 8",0
hostnotfound    db "Host Not Found"

outmsg_00       db 'USER %s', 0dh, 0ah, 0
outmsg_01       db 'PASS %s', 0dh, 0ah, 0
outmsg_02       db 'STAT', 0dh, 0ah, 0
outmsg_03       db 'RETR %u', 0dh, 0ah, 0

POP3S struc                                             ; Server STRUCTURE
        Server_name     db 64 dup(0)    ; Server name / IP
        User_name       db 64 dup(0)    ; User name
        Password        db 64 dup(0)    ; Password
        Email_Address   db 128 dup(0)   ; E-Mail address
        InboxPath       db 128 dup(0)   ; Path to put new messages
        Flags           dd 0            ;
        Stage           dd 0            ; Stage of getting mail
        SocketH         dd 0            ;
        Recv_buff       db 512 dup(0)   ;
        Connectdata     db 16 dup(0)    ;
        Messages        dd 0            ; Number of messages on server
        CMessage        dd 0            ; Current message downloading
        CurrentFH       dd 0            ; File handle used to save messages
POP3S ends

POP3_active     dd 0
POP3_servers    dd 0
 ; If you want to add a default server,
 ; put it here and change POP3_servers
 ; POP3S <'servername','username','password','emailaddress','folder',0,0,0,?,?,?,?>
;POP3_s   POP3S 10 dup(<>)




buff       db 128 dup(0)   ;
recvbuff       db 512 dup(0)   ;


ClassName       db "SimpleWinClass",0
AppName         db "Mega Mail v0.1",0
TestString      db "Mail Start:",0
num1            db " %lu ",0
errornum        db "Error %lu",0

hInstance       HINSTANCE ?
CommandLine     LPSTR ?
hwnd            HWND ?

.code

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG

	mov   wc.cbSize,SIZEOF WNDCLASSEX
        mov   wc.style, CS_BYTEALIGNWINDOW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
        push  hInstance
        pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
        invoke LoadIcon,NULL,IDI_APPLICATION

	mov   wc.hIcon,eax
        mov   wc.hIconSm,0
        invoke LoadCursor,NULL,IDC_ARROW

	mov   wc.hCursor,eax
        invoke RegisterClassEx, addr wc

        INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,
           CW_USEDEFAULT,CW_USEDEFAULT,
          300,300,            ;size
          NULL,NULL,\
           hInst,NULL
        mov   hwnd,eax


        INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
        INVOKE UpdateWindow, hwnd

        .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
        .ENDW
        mov     eax,msg.wParam
        ret
WinMain endp
printf proc p1:dword, p2:dword, p3:dword
        push p3
        push p2
        push p1
        call wsprintfA
        add esp, 12
        ret
printf endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        LOCAL hdc:HDC
        LOCAL ps:PAINTSTRUCT
        LOCAL POP3_s:POP3S
        LOCAL LServerPT0:DWORD, LServerID0:DWORD
        LOCAL   wsadata1:WSADATA


	mov   eax,uMsg
	.IF eax==WM_DESTROY
		invoke PostQuitMessage,NULL
        .ELSEIF eax==WM_PAINT
                invoke BeginPaint,hWnd, ADDR ps
                mov    hdc,eax

                invoke TextOut,hdc,0,0,ADDR TestString,(SIZEOF TestString) -1

                invoke WSAStartup, 0101h, ADDR wsadata1
                cmp eax,0
                jne wsfail2

                xor ecx, ecx
                xor esi, esi

                mov eax, ecx
                add eax, EMM_0000
                ;lea ebx, POP3_s[esi].Server_name
                ;lea edx, POP3_s[esi].Recv_buff
                lea ebx,servername1
                lea edx,recvbuff ;POP3_s.Recv_buff
                mov POP3_s[esi].SocketH, 0
                ;inc POP3_active
                invoke WSAAsyncGetHostByName,hWnd, EMM_0000, ebx, edx, 512
                or eax,eax
                jnz works1

                invoke WSAGetLastError
                invoke printf,ADDR buff,ADDR errornum,eax
                jmp gonum
works1:

                ;invoke printf,ADDR buff,ADDR num1,eax
                jmp wsfail2
gonum:
                invoke lstrlen,ADDR buff
                invoke TextOut,hdc,0,40,ADDR buff,eax
wsfail2:
                invoke EndPaint,hWnd, ADDR ps
                xor eax,eax
                ret
        .ELSEIF eax==EMM_0000
                invoke GetDC,hWnd
                mov    hdc,eax

                invoke TextOut,hdc,0,16,ADDR s1,(SIZEOF s1) -1

                cmp word ptr [lParam+2],0
                je noerr2
                xor eax,eax
                mov ax,word ptr [lParam+2]

                cmp eax,WSAHOST_NOT_FOUND
                jne unerr
                invoke TextOut,hdc,60,16,ADDR hostnotfound,(SIZEOF hostnotfound)
                jmp error
unerr:
                invoke printf,ADDR buff,ADDR num1,eax
                invoke lstrlen,ADDR buff
                invoke TextOut,hdc,60,16,ADDR buff,eax

                jmp error
noerr2:

                mov eax,dword ptr [recvbuff+12]
                ;mov eax,dword ptr POP3_s.Recv_buff[12]
                mov eax,dword ptr [eax]
                mov eax,dword ptr [eax]
                mov  word ptr POP3_s.Connectdata, AF_INET
                mov  word ptr POP3_s.Connectdata[2], 6e00h
                mov dword ptr POP3_s.Connectdata[4], eax
                mov dword ptr POP3_s.Connectdata[8], 0
                mov dword ptr POP3_s.Connectdata[12], 0


                invoke socket, AF_INET, SOCK_STREAM, 0
                cmp eax,-1
                jne noerrors

                invoke printf,ADDR buff,ADDR num1,eax
                invoke lstrlen,ADDR buff
                invoke TextOut,hdc,60,16,ADDR buff,eax

                jmp error

noerrors:
                mov POP3_s.SocketH,eax


                invoke WSAAsyncSelect, eax, hWnd, EMM_1000, FD_CONNECT

                lea ebx,POP3_s.Connectdata

                invoke connect,POP3_s.SocketH,ebx,16

error:
                invoke ReleaseDC,hWnd,hdc
                ret

        .ELSEIF eax==EMM_1000

                invoke GetDC,hWnd
                mov    hdc,eax
                invoke TextOut,hdc,0,32,ADDR s2,(SIZEOF s2) -1

                cmp word ptr [lParam+2],0
                je noerr3
                xor eax,eax
                mov ax,word ptr [lParam+2]

                invoke printf,ADDR buff,ADDR num1,eax
                invoke lstrlen,ADDR buff
                invoke TextOut,hdc,60,16,ADDR buff,eax

                invoke closesocket,POP3_s.SocketH

                jmp error3
noerr3:


                mov POP3_s.Stage,stage_00
                mov edx,EMM_2000
                invoke WSAAsyncSelect, POP3_s.SocketH, hWnd, edx, FD_READ
                xor eax,eax
error3:
                invoke ReleaseDC,hWnd,hdc
                ret
        .ELSEIF eax==EMM_2000

                invoke GetDC,hWnd
                mov    hdc,eax
                invoke TextOut,hdc,0,48,ADDR s3,(SIZEOF s3) -1

                invoke printf,ADDR buff,ADDR num1,[POP3_s.Stage]
                invoke lstrlen,ADDR buff
                invoke TextOut,hdc,60,48,ADDR buff,eax


                cmp word ptr [lParam+2],0
                je noerr4
                xor eax,eax
                mov ax,word ptr [lParam+2]

                invoke printf,ADDR buff,ADDR num1,eax
                invoke lstrlen,ADDR buff
                invoke TextOut,hdc,60,16,ADDR buff,eax

                jmp error4
noerr4:


                call POP3_s.Stage

error4:
                invoke ReleaseDC,hWnd,hdc
                ret

        .ELSEIF eax==WM_MOUSEMOVE
                invoke GetDC,hWnd
                mov    hdc,eax

                ;invoke TextOut,hdc,0,0,ADDR s1,(SIZEOF s1) -1

                invoke ReleaseDC,hWnd,hdc

        .ELSE
                invoke DefWindowProc,hWnd,uMsg,wParam,lParam
                ret
	.ENDIF
        xor    eax,eax
	ret

;============================================================================;
;|| Stage 00    AUTHORIZATION STARTS                                       ||;
;||             Check recieved server state                                ||;
;||             Send USER xxx command                                      ||;
;============================================================================;
stage_00:

;        mov LServerPT0, esi
;        add eax, 4000;ID_SERVERSTAT
;        mov LServerID0, eax

        ;lea ebx, recvbbuff

        invoke recv, POP3_s.SocketH, ADDR recvbuff, 512, NULL

        invoke TextOut,hdc,0,128,ADDR recvbuff,40

        ;cmp eax, 0
        ; jle shoWSE0
        mov esi, LServerPT0
        lea ebx, POP3_s.Recv_buff

        ;cmp byte ptr [ebx], '+'
        ; jne ServeE0

        mov POP3_s.Stage, offset stage_01

        lea esi,username1
        push esi
        push offset outmsg_00
        push offset buff
        call wsprintfA
        add esp, 12

        invoke lstrlen,ADDR buff

        invoke send, POP3_s.SocketH, ADDR buff, eax, NULL

        invoke TextOut,hdc,0,64,ADDR s4,(SIZEOF s4) -1

;        cmp eax, -1
;         je shoWSE0

        xor eax, eax
        ret

stage_01:
        invoke TextOut,hdc,0,80,ADDR s5,(SIZEOF s4) -1

        invoke recv, POP3_s.SocketH, ADDR recvbuff, 512, NULL

        invoke TextOut,hdc,0,128,ADDR recvbuff,40

        mov POP3_s.Stage, offset stage_02

        lea esi,pass1
        push esi
        push offset outmsg_01
        push offset buff
        call wsprintfA
        add esp, 12

        invoke lstrlen,ADDR buff

        invoke send, POP3_s.SocketH, ADDR buff, eax, NULL

        ret
stage_02:
        mov POP3_s.Stage, offset stage_03
        invoke TextOut,hdc,0,96,ADDR s6,(SIZEOF s4) -1

        invoke recv, POP3_s.SocketH, ADDR recvbuff, 512, NULL

        invoke TextOut,hdc,0,128,ADDR recvbuff,40

        invoke lstrlen, offset outmsg_02
        invoke send, POP3_s.SocketH, offset outmsg_02, eax, NULL
        ret


stage_03:
        ;mov POP3_s.Stage, offset stage_04
        invoke TextOut,hdc,0,96,ADDR s7,(SIZEOF s4) -1

        invoke recv, POP3_s.SocketH, ADDR recvbuff, 512, NULL

        invoke TextOut,hdc,0,128+32,ADDR recvbuff,40

;        ret
;stage_04:
        invoke TextOut,hdc,0,96,ADDR s8,(SIZEOF s4) -1
        invoke closesocket,POP3_s.SocketH
        ret

WndProc endp


start:

	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
        invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

        end start
